diff --git a/rsvg-filter.c b/rsvg-filter.c
index 705f14c..81cce75 100644
--- a/rsvg-filter.c
+++ b/rsvg-filter.c
@@ -1719,9 +2203,11 @@ rsvg_filter_primitive_merge_node_set_atts (RsvgNode * self,
 static void
 rsvg_filter_primitive_merge_node_free (RsvgNode * self)
 {
-    RsvgFilterPrimitive *upself;
-    upself = (RsvgFilterPrimitive *) self;
-    g_string_free (upself->in, TRUE);
+    RsvgFilterPrimitive *merge_node;
+
+    merge_node = (RsvgFilterPrimitive *) self;
+    g_string_free (merge_node->in, TRUE);
+
     _rsvg_node_free (self);
 }
 
@@ -1736,10 +2222,10 @@ rsvg_new_filter_primitive_merge_node (void)
 {
     RsvgFilterPrimitive *filter;
     filter = g_new (RsvgFilterPrimitive, 1);
-    _rsvg_node_init (&filter->super);
+    _rsvg_node_init (&filter->super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_MERGE_NODE);
     filter->in = g_string_new ("none");
     filter->super.free = rsvg_filter_primitive_merge_node_free;
-    filter->render = &rsvg_filter_primitive_merge_node_render;
+    filter->render = rsvg_filter_primitive_merge_node_render;
     filter->super.set_atts = rsvg_filter_primitive_merge_node_set_atts;
     return (RsvgNode *) filter;
 }
@@ -1747,16 +2233,16 @@ rsvg_new_filter_primitive_merge_node (void)
 /*************************************************************/
 /*************************************************************/
 
-typedef struct _RsvgFilterPrimitiveColourMatrix
- RsvgFilterPrimitiveColourMatrix;
+typedef struct _RsvgFilterPrimitiveColorMatrix
+ RsvgFilterPrimitiveColorMatrix;
 
-struct _RsvgFilterPrimitiveColourMatrix {
+struct _RsvgFilterPrimitiveColorMatrix {
     RsvgFilterPrimitive super;
     gint *KernelMatrix;
 };
 
 static void
-rsvg_filter_primitive_colour_matrix_render (RsvgFilterPrimitive * self, RsvgFilterContext * ctx)
+rsvg_filter_primitive_color_matrix_render (RsvgFilterPrimitive * self, RsvgFilterContext * ctx)
 {
     guchar ch;
     gint x, y;
@@ -1767,26 +2253,35 @@ rsvg_filter_primitive_colour_matrix_render (RsvgFilterPrimitive * self, RsvgFilt
     guchar *in_pixels;
     guchar *output_pixels;
 
-    RsvgFilterPrimitiveColourMatrix *upself;
+    RsvgFilterPrimitiveColorMatrix *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
+    cairo_surface_t *output, *in;
 
     int sum;
 
-    upself = (RsvgFilterPrimitiveColourMatrix *) self;
+    upself = (RsvgFilterPrimitiveColorMatrix *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
+
+    cairo_surface_flush (in);
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    in_pixels = cairo_image_surface_get_data (in);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    rowstride = cairo_image_surface_get_stride (in);
+
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
+
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++) {
@@ -1833,35 +2328,35 @@ rsvg_filter_primitive_colour_matrix_render (RsvgFilterPrimitive * self, RsvgFilt
             }
         }
 
+    cairo_surface_mark_dirty (output);
+
     rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
+    cairo_surface_destroy (in);
+    cairo_surface_destroy(output);
 }
 
 static void
-rsvg_filter_primitive_colour_matrix_free (RsvgNode * self)
+rsvg_filter_primitive_color_matrix_free (RsvgNode * self)
 {
-    RsvgFilterPrimitiveColourMatrix *upself;
+    RsvgFilterPrimitiveColorMatrix *matrix;
 
-    upself = (RsvgFilterPrimitiveColourMatrix *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    if (upself->KernelMatrix)
-        g_free (upself->KernelMatrix);
-    _rsvg_node_free (self);
+    matrix = (RsvgFilterPrimitiveColorMatrix *) self;
+    g_free (matrix->KernelMatrix);
+    
+    rsvg_filter_primitive_free (self);
 }
 
 static void
-rsvg_filter_primitive_colour_matrix_set_atts (RsvgNode * self, RsvgHandle * ctx,
+rsvg_filter_primitive_color_matrix_set_atts (RsvgNode * self, RsvgHandle * ctx,
                                               RsvgPropertyBag * atts)
 {
     gint type;
     guint listlen = 0;
     const char *value;
-    RsvgFilterPrimitiveColourMatrix *filter;
+    RsvgFilterPrimitiveColorMatrix *filter;
 
-    filter = (RsvgFilterPrimitiveColourMatrix *) self;
+    filter = (RsvgFilterPrimitiveColorMatrix *) self;
 
     type = 0;
 
@@ -1966,20 +2461,20 @@ rsvg_filter_primitive_colour_matrix_set_atts (RsvgNode * self, RsvgHandle * ctx,
 }
 
 RsvgNode *
-rsvg_new_filter_primitive_colour_matrix (void)
+rsvg_new_filter_primitive_color_matrix (void)
 {
-    RsvgFilterPrimitiveColourMatrix *filter;
-    filter = g_new (RsvgFilterPrimitiveColourMatrix, 1);
-    _rsvg_node_init (&filter->super.super);
+    RsvgFilterPrimitiveColorMatrix *filter;
+    filter = g_new (RsvgFilterPrimitiveColorMatrix, 1);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_COLOR_MATRIX);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
         filter->super.height.factor = 'n';
     filter->KernelMatrix = NULL;
-    filter->super.render = &rsvg_filter_primitive_colour_matrix_render;
-    filter->super.super.free = &rsvg_filter_primitive_colour_matrix_free;
+    filter->super.render = rsvg_filter_primitive_color_matrix_render;
+    filter->super.super.free = rsvg_filter_primitive_color_matrix_free;
 
-    filter->super.super.set_atts = rsvg_filter_primitive_colour_matrix_set_atts;
+    filter->super.super.set_atts = rsvg_filter_primitive_color_matrix_set_atts;
     return (RsvgNode *) filter;
 }
 
@@ -2002,8 +2497,9 @@ struct _RsvgNodeComponentTransferFunc {
     gint slope;
     gint intercept;
     gint amplitude;
-    gdouble exponent;
     gint offset;
+    gdouble exponent;
+    char channel;
 };
 
 struct _RsvgFilterPrimitiveComponentTransfer {
@@ -2021,14 +2517,17 @@ table_component_transfer_func (gint C, RsvgNodeComponentTransferFunc * user_data
 {
     guint k;
     gint vk, vk1, distancefromlast;
+    guint num_values;
 
     if (!user_data->nbTableValues)
         return C;
 
-    k = (C * (user_data->nbTableValues - 1)) / 255;
+    num_values = user_data->nbTableValues;
+
+    k = (C * (num_values - 1)) / 255;
 
-    vk = user_data->tableValues[k];
-    vk1 = user_data->tableValues[k + 1];
+    vk = user_data->tableValues[CLAMP (k, 0, num_values - 1)];
+    vk1 = user_data->tableValues[CLAMP (k + 1, 0, num_values - 1)];
 
     distancefromlast = (C * (user_data->nbTableValues - 1)) - k * 255;
 
@@ -2045,7 +2544,7 @@ discrete_component_transfer_func (gint C, RsvgNodeComponentTransferFunc * user_d
 
     k = (C * user_data->nbTableValues) / 255;
 
-    return user_data->tableValues[k];
+    return user_data->tableValues[CLAMP (k, 0, user_data->nbTableValues)];
 }
 
 static gint
@@ -2079,7 +2578,6 @@ rsvg_filter_primitive_component_transfer_render (RsvgFilterPrimitive *
 {
     gint x, y, c;
     guint i;
-    gint temp;
     gint rowstride, height, width;
     RsvgIRect boundarys;
     RsvgNodeComponentTransferFunc *channels[4];
@@ -2088,48 +2586,57 @@ rsvg_filter_primitive_component_transfer_render (RsvgFilterPrimitive *
     gint achan = ctx->channelmap[3];
     guchar *in_pixels;
     guchar *output_pixels;
+    cairo_surface_t *output, *in;
 
-    RsvgFilterPrimitiveComponentTransfer *upself;
-
-    GdkPixbuf *output;
-    GdkPixbuf *in;
-    upself = (RsvgFilterPrimitiveComponentTransfer *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     for (c = 0; c < 4; c++) {
-        char channel = "RGBA"[c];
+        char channel = "rgba"[c]; /* see rsvg_standard_element_start() for where these chars come from */
         for (i = 0; i < self->super.children->len; i++) {
-            RsvgNodeComponentTransferFunc *temp;
-            temp = (RsvgNodeComponentTransferFunc *)
-                g_ptr_array_index (self->super.children, i);
-            if (!strncmp (temp->super.type->str, "feFunc", 6))
-                if (temp->super.type->str[6] == channel) {
+            RsvgNode *child_node;
+
+            child_node = (RsvgNode *) g_ptr_array_index (self->super.children, i);
+            if (RSVG_NODE_TYPE (child_node) == RSVG_NODE_TYPE_COMPONENT_TRANFER_FUNCTION) {
+                RsvgNodeComponentTransferFunc *temp = (RsvgNodeComponentTransferFunc *) child_node;
+
+                if (temp->channel == channel) {
                     functions[ctx->channelmap[c]] = temp->function;
                     channels[ctx->channelmap[c]] = temp;
                     break;
                 }
+            }
         }
         if (i == self->super.children->len)
-            functions[c] = identity_component_transfer_func;
+            functions[ctx->channelmap[c]] = identity_component_transfer_func;
 
     }
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    cairo_surface_flush (in);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    in_pixels = cairo_image_surface_get_data (in);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    rowstride = cairo_image_surface_get_stride (in);
+
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
+
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++) {
             inpix = in_pixels + (y * rowstride + x * 4);
             for (c = 0; c < 4; c++) {
+                gint temp;
                 int inval;
                 if (c != achan) {
                     if (inpix[achan] == 0)
@@ -2151,10 +2658,13 @@ rsvg_filter_primitive_component_transfer_render (RsvgFilterPrimitive *
                     outpix[ctx->channelmap[c]] * outpix[achan] / 255;
             output_pixels[y * rowstride + x * 4 + achan] = outpix[achan];
         }
+
+    cairo_surface_mark_dirty (output);
+
     rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -2190,15 +2700,14 @@ rsvg_new_filter_primitive_component_transfer (void)
     RsvgFilterPrimitiveComponentTransfer *filter;
 
     filter = g_new (RsvgFilterPrimitiveComponentTransfer, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_COMPONENT_TRANSFER);
     filter->super.result = g_string_new ("none");
     filter->super.in = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
         filter->super.height.factor = 'n';
-    filter->super.render = &rsvg_filter_primitive_component_transfer_render;
-
+    filter->super.render = rsvg_filter_primitive_component_transfer_render;
+    filter->super.super.free = rsvg_filter_primitive_free;
     filter->super.super.set_atts = rsvg_filter_primitive_component_transfer_set_atts;
-
     return (RsvgNode *) filter;
 }
 
@@ -2263,12 +2772,13 @@ rsvg_new_node_component_transfer_function (char channel)
 {
     RsvgNodeComponentTransferFunc *filter;
 
-    filter = g_new (RsvgNodeComponentTransferFunc, 1);
-    _rsvg_node_init (&filter->super);
+    filter = g_new0 (RsvgNodeComponentTransferFunc, 1);
+    _rsvg_node_init (&filter->super, RSVG_NODE_TYPE_COMPONENT_TRANFER_FUNCTION);
     filter->super.free = rsvg_component_transfer_function_free;
     filter->super.set_atts = rsvg_node_component_transfer_function_set_atts;
     filter->function = identity_component_transfer_func;
     filter->nbTableValues = 0;
+    filter->channel = channel;
     return (RsvgNode *) filter;
 }
 
@@ -2298,8 +2808,7 @@ rsvg_filter_primitive_erode_render (RsvgFilterPrimitive * self, RsvgFilterContex
 
     RsvgFilterPrimitiveErode *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
+    cairo_surface_t *output, *in;
 
     gint kx, ky;
     guchar val;
@@ -2308,20 +2817,29 @@ rsvg_filter_primitive_erode_render (RsvgFilterPrimitive * self, RsvgFilterContex
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    cairo_surface_flush (in);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    in_pixels = cairo_image_surface_get_data (in);
+
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
+
+    rowstride = cairo_image_surface_get_stride (in);
 
     /* scale the radius values */
-    kx = upself->rx * ctx->paffine[0];
-    ky = upself->ry * ctx->paffine[3];
+    kx = upself->rx * ctx->paffine.xx;
+    ky = upself->ry * ctx->paffine.yy;
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++)
@@ -2349,21 +2867,13 @@ rsvg_filter_primitive_erode_render (RsvgFilterPrimitive * self, RsvgFilterContex
                     }
                 output_pixels[y * rowstride + x * 4 + ch] = extreme;
             }
-    rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
-}
+    cairo_surface_mark_dirty (output);
 
-static void
-rsvg_filter_primitive_erode_free (RsvgNode * self)
-{
-    RsvgFilterPrimitiveErode *upself;
+    rsvg_filter_store_result (self->result, output, ctx);
 
-    upself = (RsvgFilterPrimitiveErode *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    _rsvg_node_free (self);
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -2406,7 +2916,7 @@ rsvg_new_filter_primitive_erode (void)
 {
     RsvgFilterPrimitiveErode *filter;
     filter = g_new (RsvgFilterPrimitiveErode, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_ERODE);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
@@ -2414,8 +2924,8 @@ rsvg_new_filter_primitive_erode (void)
     filter->rx = 0;
     filter->ry = 0;
     filter->mode = 0;
-    filter->super.render = &rsvg_filter_primitive_erode_render;
-    filter->super.super.free = &rsvg_filter_primitive_erode_free;
+    filter->super.render = rsvg_filter_primitive_erode_render;
+    filter->super.super.free = rsvg_filter_primitive_free;
     filter->super.super.set_atts = rsvg_filter_primitive_erode_set_atts;
     return (RsvgNode *) filter;
 }
@@ -2451,25 +2961,41 @@ rsvg_filter_primitive_composite_render (RsvgFilterPrimitive * self, RsvgFilterCo
 
     RsvgFilterPrimitiveComposite *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
-    GdkPixbuf *in2;
+    cairo_surface_t *output, *in, *in2;
 
     upself = (RsvgFilterPrimitiveComposite *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
+
+    cairo_surface_flush (in);
+
     in2 = rsvg_filter_get_in (upself->in2, ctx);
-    in2_pixels = gdk_pixbuf_get_pixels (in2);
+    if (in2 == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    cairo_surface_flush (in2);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    in_pixels = cairo_image_surface_get_data (in);
+    in2_pixels = cairo_image_surface_get_data (in2);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
+
+    rowstride = cairo_image_surface_get_stride (in);
+
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        cairo_surface_destroy (in2);
+        return;
+    }
+
+    output_pixels = cairo_image_surface_get_data (output);
 
     if (upself->mode == COMPOSITE_MODE_ARITHMETIC)
         for (y = boundarys.y0; y < boundarys.y1; y++)
@@ -2557,23 +3083,24 @@ rsvg_filter_primitive_composite_render (RsvgFilterPrimitive * self, RsvgFilterCo
                 output_pixels[4 * x + y * rowstride + 3] = qr;
             }
 
+    cairo_surface_mark_dirty (output);
+
     rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (in2));
-    g_object_unref (G_OBJECT (output));
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (in2);
+    cairo_surface_destroy (output);
 }
 
 static void
 rsvg_filter_primitive_composite_free (RsvgNode * self)
 {
-    RsvgFilterPrimitiveComposite *upself;
+    RsvgFilterPrimitiveComposite *composite;
 
-    upself = (RsvgFilterPrimitiveComposite *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    g_string_free (upself->in2, TRUE);
-    _rsvg_node_free (self);
+    composite = (RsvgFilterPrimitiveComposite *) self;
+    g_string_free (composite->in2, TRUE);
+
+    rsvg_filter_primitive_free (self);
 }
 
 static void
@@ -2631,7 +3158,7 @@ rsvg_new_filter_primitive_composite (void)
 {
     RsvgFilterPrimitiveComposite *filter;
     filter = g_new (RsvgFilterPrimitiveComposite, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_COMPOSITE);
     filter->mode = COMPOSITE_MODE_OVER;
     filter->super.in = g_string_new ("none");
     filter->in2 = g_string_new ("none");
@@ -2642,8 +3169,8 @@ rsvg_new_filter_primitive_composite (void)
     filter->k2 = 0;
     filter->k3 = 0;
     filter->k4 = 0;
-    filter->super.render = &rsvg_filter_primitive_composite_render;
-    filter->super.super.free = &rsvg_filter_primitive_composite_free;
+    filter->super.render = rsvg_filter_primitive_composite_render;
+    filter->super.super.free = rsvg_filter_primitive_composite_free;
     filter->super.super.set_atts = rsvg_filter_primitive_composite_set_atts;
     return (RsvgNode *) filter;
 }
@@ -2659,53 +3186,43 @@ rsvg_filter_primitive_flood_render (RsvgFilterPrimitive * self, RsvgFilterContex
     gint rowstride, height, width;
     RsvgIRect boundarys;
     guchar *output_pixels;
-    GdkPixbuf *output;
-    char pixcolour[4];
+    cairo_surface_t *output;
+    char pixcolor[4];
     RsvgFilterPrimitiveOutput out;
 
-    guint32 colour = self->super.state->flood_color;
+    guint32 color = self->super.state->flood_color;
     guint8 opacity = self->super.state->flood_opacity;
 
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     height = ctx->height;
     width = ctx->width;
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
-    rowstride = gdk_pixbuf_get_rowstride (output);
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL)
+        return;
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    rowstride = cairo_image_surface_get_stride (output);
+
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (i = 0; i < 3; i++)
-        pixcolour[i] = (int) (((unsigned char *)
-                               (&colour))[2 - i]) * opacity / 255;
-    pixcolour[3] = opacity;
+        pixcolor[i] = (int) (((unsigned char *)
+                               (&color))[2 - i]) * opacity / 255;
+    pixcolor[3] = opacity;
 
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++)
             for (i = 0; i < 4; i++)
-                output_pixels[4 * x + y * rowstride + ctx->channelmap[i]] = pixcolour[i];
+                output_pixels[4 * x + y * rowstride + ctx->channelmap[i]] = pixcolor[i];
+
+    cairo_surface_mark_dirty (output);
 
-    out.result = output;
-    out.Rused = 1;
-    out.Gused = 1;
-    out.Bused = 1;
-    out.Aused = 1;
+    out.surface = output;
     out.bounds = boundarys;
 
     rsvg_filter_store_output (self->result, out, ctx);
 
-    g_object_unref (G_OBJECT (output));
-}
-
-static void
-rsvg_filter_primitive_flood_free (RsvgNode * self)
-{
-    RsvgFilterPrimitive *upself;
-
-    upself = (RsvgFilterPrimitive *) self;
-    g_string_free (upself->result, TRUE);
-    g_string_free (upself->in, TRUE);
-    _rsvg_node_free (self);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -2736,12 +3253,12 @@ rsvg_new_filter_primitive_flood (void)
 {
     RsvgFilterPrimitive *filter;
     filter = g_new (RsvgFilterPrimitive, 1);
-    _rsvg_node_init (&filter->super);
+    _rsvg_node_init (&filter->super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_FLOOD);
     filter->in = g_string_new ("none");
     filter->result = g_string_new ("none");
     filter->x.factor = filter->y.factor = filter->width.factor = filter->height.factor = 'n';
-    filter->render = &rsvg_filter_primitive_flood_render;
-    filter->super.free = &rsvg_filter_primitive_flood_free;
+    filter->render = rsvg_filter_primitive_flood_render;
+    filter->super.free = rsvg_filter_primitive_free;
     filter->super.set_atts = rsvg_filter_primitive_flood_set_atts;
     return (RsvgNode *) filter;
 }
@@ -2773,9 +3290,7 @@ rsvg_filter_primitive_displacement_map_render (RsvgFilterPrimitive * self, RsvgF
 
     RsvgFilterPrimitiveDisplacementMap *upself;
 
-    GdkPixbuf *output;
-    GdkPixbuf *in;
-    GdkPixbuf *in2;
+    cairo_surface_t *output, *in, *in2;
 
     double ox, oy;
 
@@ -2783,19 +3298,35 @@ rsvg_filter_primitive_displacement_map_render (RsvgFilterPrimitive * self, RsvgF
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
 
     in = rsvg_filter_get_in (self->in, ctx);
-    in_pixels = gdk_pixbuf_get_pixels (in);
+    if (in == NULL)
+        return;
+
+    cairo_surface_flush (in);
 
     in2 = rsvg_filter_get_in (upself->in2, ctx);
-    in2_pixels = gdk_pixbuf_get_pixels (in2);
+    if (in2 == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
+    cairo_surface_flush (in2);
 
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    in_pixels = cairo_image_surface_get_data (in);
+    in2_pixels = cairo_image_surface_get_data (in2);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
 
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    rowstride = cairo_image_surface_get_stride (in);
+
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        cairo_surface_destroy (in2);
+        return;
+    }
+
+    output_pixels = cairo_image_surface_get_data (output);
 
     switch (upself->xChannelSelector) {
     case 'R':
@@ -2811,8 +3342,9 @@ rsvg_filter_primitive_displacement_map_render (RsvgFilterPrimitive * self, RsvgF
         xch = 3;
         break;
     default:
-        xch = 4;
-    };
+        xch = 0;
+        break;
+    }
 
     switch (upself->yChannelSelector) {
     case 'R':
@@ -2828,48 +3360,50 @@ rsvg_filter_primitive_displacement_map_render (RsvgFilterPrimitive * self, RsvgF
         ych = 3;
         break;
     default:
-        ych = 4;
-    };
+        ych = 1;
+        break;
+    }
 
     xch = ctx->channelmap[xch];
     ych = ctx->channelmap[ych];
     for (y = boundarys.y0; y < boundarys.y1; y++)
         for (x = boundarys.x0; x < boundarys.x1; x++) {
             if (xch != 4)
-                ox = x + upself->scale * ctx->paffine[0] *
+                ox = x + upself->scale * ctx->paffine.xx *
                     ((double) in2_pixels[y * rowstride + x * 4 + xch] / 255.0 - 0.5);
             else
                 ox = x;
 
             if (ych != 4)
-                oy = y + upself->scale * ctx->paffine[3] *
+                oy = y + upself->scale * ctx->paffine.yy *
                     ((double) in2_pixels[y * rowstride + x * 4 + ych] / 255.0 - 0.5);
             else
                 oy = y;
 
             for (ch = 0; ch < 4; ch++) {
                 output_pixels[y * rowstride + x * 4 + ch] =
-                    gdk_pixbuf_get_interp_pixel (in_pixels, ox, oy, ch, boundarys, rowstride);
+                    get_interp_pixel (in_pixels, ox, oy, ch, boundarys, rowstride);
             }
         }
 
+    cairo_surface_mark_dirty (output);
+
     rsvg_filter_store_result (self->result, output, ctx);
 
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (in2));
-    g_object_unref (G_OBJECT (output));
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (in2);
+    cairo_surface_destroy (output);
 }
 
 static void
 rsvg_filter_primitive_displacement_map_free (RsvgNode * self)
 {
-    RsvgFilterPrimitiveDisplacementMap *upself;
+    RsvgFilterPrimitiveDisplacementMap *dmap;
 
-    upself = (RsvgFilterPrimitiveDisplacementMap *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    g_string_free (upself->in2, TRUE);
-    _rsvg_node_free (self);
+    dmap = (RsvgFilterPrimitiveDisplacementMap *) self;
+    g_string_free (dmap->in2, TRUE);
+
+    rsvg_filter_primitive_free (self);
 }
 
 static void
@@ -2908,11 +3442,11 @@ rsvg_filter_primitive_displacement_map_set_atts (RsvgNode * self, RsvgHandle * c
 }
 
 RsvgNode *
-rsvg_new_filter_primitive_displacement_map ()
+rsvg_new_filter_primitive_displacement_map (void)
 {
     RsvgFilterPrimitiveDisplacementMap *filter;
     filter = g_new (RsvgFilterPrimitiveDisplacementMap, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_DISPLACEMENT_MAP);
     filter->super.in = g_string_new ("none");
     filter->in2 = g_string_new ("none");
     filter->super.result = g_string_new ("none");
@@ -2921,8 +3455,8 @@ rsvg_new_filter_primitive_displacement_map ()
     filter->xChannelSelector = ' ';
     filter->yChannelSelector = ' ';
     filter->scale = 0;
-    filter->super.render = &rsvg_filter_primitive_displacement_map_render;
-    filter->super.super.free = &rsvg_filter_primitive_displacement_map_free;
+    filter->super.render = rsvg_filter_primitive_displacement_map_render;
+    filter->super.super.free = rsvg_filter_primitive_displacement_map_free;
     filter->super.super.set_atts = rsvg_filter_primitive_displacement_map_set_atts;
     return (RsvgNode *) filter;
 }
@@ -3172,14 +3706,22 @@ rsvg_filter_primitive_turbulence_render (RsvgFilterPrimitive * self, RsvgFilterC
     gint x, y, tileWidth, tileHeight, rowstride, width, height;
     RsvgIRect boundarys;
     guchar *output_pixels;
-    GdkPixbuf *output;
-    gdouble affine[6];
-    GdkPixbuf *in;
+    cairo_surface_t *output, *in;
+    cairo_matrix_t affine;
+
+    affine = ctx->paffine;
+    if (cairo_matrix_invert (&affine) != CAIRO_STATUS_SUCCESS)
+      return;
 
     in = rsvg_filter_get_in (self->in, ctx);
-    height = gdk_pixbuf_get_height (in);
-    width = gdk_pixbuf_get_width (in);
-    rowstride = gdk_pixbuf_get_rowstride (in);
+    if (in == NULL)
+        return;
+
+    cairo_surface_flush (in);
+
+    height = cairo_image_surface_get_height (in);
+    width = cairo_image_surface_get_width (in);
+    rowstride = cairo_image_surface_get_stride (in);
 
     upself = (RsvgFilterPrimitiveTurbulence *) self;
     boundarys = rsvg_filter_primitive_get_bounds (self, ctx);
@@ -3187,18 +3729,21 @@ rsvg_filter_primitive_turbulence_render (RsvgFilterPrimitive * self, RsvgFilterC
     tileWidth = (boundarys.x1 - boundarys.x0);
     tileHeight = (boundarys.y1 - boundarys.y0);
 
-    output = _rsvg_pixbuf_new_cleared (GDK_COLORSPACE_RGB, 1, 8, width, height);
-    output_pixels = gdk_pixbuf_get_pixels (output);
+    output = _rsvg_image_surface_new (width, height);
+    if (output == NULL) {
+        cairo_surface_destroy (in);
+        return;
+    }
 
-    _rsvg_affine_invert (affine, ctx->paffine);
+    output_pixels = cairo_image_surface_get_data (output);
 
     for (y = 0; y < tileHeight; y++) {
         for (x = 0; x < tileWidth; x++) {
             gint i;
             double point[2];
             guchar *pixel;
-            point[0] = affine[0] * (x + boundarys.x0) + affine[2] * (y + boundarys.y0) + affine[4];
-            point[1] = affine[1] * (x + boundarys.x0) + affine[3] * (y + boundarys.y0) + affine[5];
+            point[0] = affine.xx * (x + boundarys.x0) + affine.xy * (y + boundarys.y0) + affine.x0;
+            point[1] = affine.yx * (x + boundarys.x0) + affine.yy * (y + boundarys.y0) + affine.y0;
 
             pixel = output_pixels + 4 * (x + boundarys.x0) + (y + boundarys.y0) * rowstride;
 
@@ -3224,21 +3769,12 @@ rsvg_filter_primitive_turbulence_render (RsvgFilterPrimitive * self, RsvgFilterC
         }
     }
 
-    rsvg_filter_store_result (self->result, output, ctx);
-
-    g_object_unref (G_OBJECT (in));
-    g_object_unref (G_OBJECT (output));
-}
+    cairo_surface_mark_dirty (output);
 
-static void
-rsvg_filter_primitive_turbulence_free (RsvgNode * self)
-{
-    RsvgFilterPrimitiveTurbulence *upself;
+    rsvg_filter_store_result (self->result, output, ctx);
 
-    upself = (RsvgFilterPrimitiveTurbulence *) self;
-    g_string_free (upself->super.result, TRUE);
-    g_string_free (upself->super.in, TRUE);
-    _rsvg_node_free (self);
+    cairo_surface_destroy (in);
+    cairo_surface_destroy (output);
 }
 
 static void
@@ -3283,7 +3819,7 @@ rsvg_new_filter_primitive_turbulence (void)
 {
     RsvgFilterPrimitiveTurbulence *filter;
     filter = g_new (RsvgFilterPrimitiveTurbulence, 1);
-    _rsvg_node_init (&filter->super.super);
+    _rsvg_node_init (&filter->super.super, RSVG_NODE_TYPE_FILTER_PRIMITIVE_TURBULENCE);
     filter->super.in = g_string_new ("none");
     filter->super.result = g_string_new ("none");
     filter->super.x.factor = filter->super.y.factor = filter->super.width.factor =
